namespace CMSMicroservice.Application.TransactionsCQ.Commands.CreateNewTransactions;
public class CreateNewTransactionsCommandValidator : AbstractValidator<CreateNewTransactionsCommand>
{
    public CreateNewTransactionsCommandValidator()
    {
        RuleFor(model => model.Amount)
            .NotNull();
        RuleFor(model => model.Description)
            .NotEmpty();
        RuleFor(model => model.PaymentStatus)
            .IsInEnum()
            .NotNull();
        RuleFor(model => model.Type)
            .IsInEnum()
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewTransactionsCommand>.CreateWithOptions((CreateNewTransactionsCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
